hirom

; Settings

!Chr_0 = "\0"
!Chr_9 = "\t"
!Chr_10 = "\n"
!Chr_11 = "\v"
!Chr_12 = "\f"
!Chr_28 = "\e"
!Chr_32 = " "
!Chr_33 = "!"
!Chr_35 = "#"
!Chr_36 = "$"
!Chr_37 = "%"
!Chr_38 = "&"
!Chr_39 = "'"
!Chr_40 = "("
!Chr_41 = ")"
!Chr_42 = "*"
!Chr_43 = "+"
!Chr_44 = ","
!Chr_45 = "-"
!Chr_46 = "."
!Chr_47 = "/"
!Chr_48 = "0"
!Chr_49 = "1"
!Chr_50 = "2"
!Chr_51 = "3"
!Chr_52 = "4"
!Chr_53 = "5"
!Chr_54 = "6"
!Chr_55 = "7"
!Chr_56 = "8"
!Chr_57 = "9"
!Chr_58 = ":"
!Chr_59 = ";"
!Chr_60 = "<"
!Chr_61 = "="
!Chr_62 = ">"
!Chr_63 = "?"
!Chr_64 = "@"
!Chr_65 = "A"
!Chr_66 = "B"
!Chr_67 = "C"
!Chr_68 = "D"
!Chr_69 = "E"
!Chr_70 = "F"
!Chr_71 = "G"
!Chr_72 = "H"
!Chr_73 = "I"
!Chr_74 = "J"
!Chr_75 = "K"
!Chr_76 = "L"
!Chr_77 = "M"
!Chr_78 = "N"
!Chr_79 = "O"
!Chr_80 = "P"
!Chr_81 = "Q"
!Chr_82 = "R"
!Chr_83 = "S"
!Chr_84 = "T"
!Chr_85 = "U"
!Chr_86 = "V"
!Chr_87 = "W"
!Chr_88 = "X"
!Chr_89 = "Y"
!Chr_90 = "Z"
!Chr_91 = "["
!Chr_92 = "\\"
!Chr_93 = "]"
!Chr_94 = "^"
!Chr_95 = "_"
!Chr_96 = "`"
!Chr_97 = "a"
!Chr_98 = "b"
!Chr_99 = "c"
!Chr_100 = "d"
!Chr_101 = "e"
!Chr_102 = "f"
!Chr_103 = "g"
!Chr_104 = "h"
!Chr_105 = "i"
!Chr_106 = "j"
!Chr_107 = "k"
!Chr_108 = "l"
!Chr_109 = "m"
!Chr_110 = "n"
!Chr_111 = "o"
!Chr_112 = "p"
!Chr_113 = "q"
!Chr_114 = "r"
!Chr_115 = "s"
!Chr_116 = "t"
!Chr_117 = "u"
!Chr_118 = "v"
!Chr_119 = "w"
!Chr_120 = "x"
!Chr_121 = "y"
!Chr_122 = "z"
!Chr_123 = "{"
!Chr_124 = "|"
!Chr_125 = "|"
!Chr_126 = "}"
!Chr_127 = "~"

macro Chr(byte, result)
    !Chr_byte #= <byte>
    !<result> = !{Chr_!{Chr_byte}}
endmacro

macro SettingsIgnoreSpaces(file, memory)
    !byte #= readfile1("<file>", !<memory>, 0)
    while !byte == $20 || !byte == $09
        !<memory> #= !<memory>+1
        !byte #= readfile1("<file>", !<memory>, 0)
    endif
endmacro

function keypart(byte) = or(and(greaterequal(byte, $30), lessequal(byte, $39)),
                            or(and(greaterequal(byte, $41), lessequal(byte, $5A)),
                               or(and(greaterequal(byte, $61), lessequal(byte, $7A)),
                                  equal(byte, $5F))))

macro SettingsReadKey(file, memory, key)
    !<key> := ""
    !byte #= readfile1("<file>", !<memory>, 0)
    while keypart(!byte)
        %Chr(!byte, chr)
        !<key> := "!<key>!chr"
        !<memory> #= !<memory>+1
        !byte #= readfile1("<file>", !<memory>, 0)
    endif
endmacro

macro SettingsReadEquals(file, memory)
    !byte #= readfile1("<file>", !<memory>, 0)
    if !byte == $3D
        !<memory> #= !<memory>+1
    else
        error "!byte : Expected '=' between key and value, in settings.conf file"
    endif
endmacro

macro SettingsReadValue(file, memory, value)
    !<value> := ""
    !byte #= readfile1("<file>", !<memory>, 0)
    if !byte == $2D
        !<value> = "-"
        !<memory> #= !<memory>+1
        !byte #= readfile1("<file>", !<memory>, 0)
    elseif !byte == $2B
        !<memory> #= !<memory>+1
        !byte #= readfile1("<file>", !<memory>, 0)
    endif
    while !byte >= $30 && !byte <= $39
        !num #= !byte-$30
        !<value> := "!<value>!num"
        !<memory> #= !<memory>+1
        !byte #= readfile1("<file>", !<memory>, 0)
    endif
    if stringsequal("!<value>", "") || stringsequal("!<value>", "-")
        error "Expected a number after 'key = ', in settings.conf file"
    endif
endmacro

macro SettingsReadKeyValueEnd(file, memory)
    !byte #= readfile1("<file>", !<memory>, 0)
    if !byte == $0A || !byte == $00
        !<memory> #= !<memory>+1
    else
        error "Expected newline or EOF after 'key = value', in settings.conf file, found byte !byte"
    endif
endmacro

macro SettingsReadKeyValue(file, memory)
    %SettingsIgnoreSpaces(<file>, <memory>)
    %SettingsReadKey(<file>, <memory>, key)
    %SettingsIgnoreSpaces(<file>, <memory>)
    %SettingsReadEquals(<file>, <memory>)
    %SettingsIgnoreSpaces(<file>, <memory>)
    %SettingsReadValue(<file>, <memory>, value)
    %SettingsIgnoreSpaces(<file>, <memory>)
    %SettingsReadKeyValueEnd(<file>, <memory>)
    !{Setting_!{key}} #= !value
endmacro

macro SettingsReadAll(file)
  !SettingsReadAll_memory #= 0
  while !SettingsReadAll_memory < filesize("<file>")
      %SettingsReadKeyValue(<file>, SettingsReadAll_memory)
  endif
endmacro

if canreadfile("settings.conf", 0, 0)
    %SettingsReadAll("settings.conf")
    !SettingsDefault = 0
else
    !SettingsDefault = 1
endif

macro typecheck(value, type, min, max)
    if <value> < <min> || <value> > <max>
        error "<value> is not a valid <type>"
    endif
endmacro

macro typecheck2(value, type, min, max)
    if <value> < <min> || <value> > <max>
        error "<value> is neither a valid signed nor unsigned <type>"
    endif
endmacro

macro Setting(var, default, type)
    if !SettingsDefault != 0 || not(defined("Setting_<var>"))
        !<var> = <default>
    else
        !value := !Setting_<var>
        if stringsequal("<type>", "bool")
            if !value != 0
                !value = 1
            endif
        elseif stringsequal("<type>", "byte")
            %typecheck2(!value, byte, -$7F, $FF)
        elseif stringsequal("<type>", "sbyte")
            %typecheck(!value, sbyte, -$7F, $7F)
        elseif stringsequal("<type>", "ubyte")
            %typecheck(!value, ubyte, 0, $FF)
        elseif stringsequal("<type>", "word")
            %typecheck2(!value, word, -$7FFF, $FFFF)
        elseif stringsequal("<type>", "sword")
            %typecheck(!value, sword, -$7FFF, $7FFF)
        elseif stringsequal("<type>", "uword")
            %typecheck(!value, uword, 0, $FFFF)
        elseif stringsequal("<type>", "long")
            %typecheck2(!value, long, -$7FFFFF, $FFFFFF)
        elseif stringsequal("<type>", "slong")
            %typecheck(!value, slong, -$7FFFFF, $7FFFFF)
        elseif stringsequal("<type>", "ulong")
            %typecheck(!value, ulong, 0, $FFFFFF)
        endif
        !<var> := !value
    endif
endmacro

; 1 = tabs increase more stats
%Setting(BetterTabs, 1, bool)

; 1 = power tab will increase hit instead of speed tab
%Setting(PowerTabIncreasesHit, 0, bool)

; 1 = compatible with jets of time randomizer, incompatible with normal game
%Setting(JetsOfTimeRando, 0, bool)

; 1 = allow stats to be decreased by tabs
%Setting(AllowStatDecrease, 0, bool)

%Setting(PowerIncrease,        2, sbyte)
%Setting(StaminaIncrease,      2, sbyte)
%Setting(SpeedIncrease,        1, sbyte)
%Setting(MagicIncrease,        2, sbyte)
%Setting(HitIncrease,          2, sbyte)
%Setting(EvadeIncrease,        2, sbyte)
%Setting(MagicDefenseIncrease, 2, sbyte)

; Setting Assertions

if !PowerTabIncreasesHit != 0
    !HitTab = "Power"
else
    !HitTab = "Speed"
endif

assert !PowerIncrease <= 99, "Power tab cannot increase more than 99 power"
assert !PowerIncrease >= -99, "Power tab cannot decrease more than 99 power"
assert !StaminaIncrease <= 99, "Power tab cannot increase more than 99 stamina"
assert !StaminaIncrease >= -99, "Power tab cannot decrease more than 99 stamina"
assert !SpeedIncrease <= 16, "Speed tab cannot increase more than 16 speed"
assert !SpeedIncrease >= -16, "Speed tab cannot decrease more than 16 speed"
assert !MagicIncrease <= 99, "Magic tab cannot increase more than 99 magic"
assert !HitIncrease <= 99, "!HitTab tab cannot increase more than 99 hit"
assert !HitIncrease >= -99, "!HitTab tab cannot decrease more than 99 hit"
assert !EvadeIncrease <= 99, "Speed tab cannot increase more than 99 evade"
assert !EvadeIncrease >= -99, "Speed tab cannot decrease more than 99 evade"
assert !MagicDefenseIncrease <= 99, "Magic tab cannot increase more than 99 magic defense"
assert !MagicDefenseIncrease >= -99, "Magic tab cannot decrease more than 99 magic defense"

if !AllowStatDecrease == 0
    assert !PowerIncrease >= 0, "Power tab cannot decrease power"
    assert !StaminaIncrease >= 0, "Power tab cannot decrease stamina"
    assert !SpeedIncrease >= 0, "Speed tab cannot decrease speed"
    assert !MagicIncrease >= 0, "Magic tab cannot decrease magic"
    assert !HitIncrease >= 0, "!HitTab cannot decrease hit"
    assert !EvadeIncrease >= 0, "Speed tab cannot decrease evade"
    assert !MagicDefenseIncrease >= 0, "Magic tab cannot decrease magic defense"
endif

; 1 = multiply exp/gold/tech points. default: 4x exp, 8x gold, 4x tech points
%Setting(IncreaseExpGoldTech, 0, bool)

; 1 = 2x exp for each 20 levels (requires !IncreasedExpGoldTech)
%Setting(GradualExpIncrease, 0, bool)

; n = levels <= 20*n are ignored for !GradualExpIncrease
%Setting(GradualExpMin, 0, sbyte)

; n = number to multiply exp by (unless GradualExpIncrease is enabled)
%Setting(ExpIncrease, 4, sbyte)

; n = number to multiply gold by
%Setting(GoldIncrease, 8, sbyte)

; n = number to multiply tech points by
%Setting(TechIncrease, 4, sbyte)


; Rom Modifications

if !IncreaseExpGoldTech != 0
; Increased Exp/Gold/Tech points

org $FDABD6
    JML AddPoints
org $FDAC05
AddPoints.ReturnPoint:

endif

if !BetterTabs != 0
org $C2B2F8
    JML TabIncrease
org $C2B30E
    TabIncrease.Return:

org $C2B298
    JML TabCondition
org $C2B2A1
    TabCondition.Allow:
org $C2B2A6
    TabCondition.Disallow:

; Helper Variables and Macros

if !JetsOfTimeRando != 0
    !PowerTabTextPointer = $F75723
else
    !PowerTabTextPointer = $CC304B
endif

!PowerTabTextW #= read2(!PowerTabTextPointer)
!PowerTabText  #= (bank(!PowerTabTextPointer)<<16)+!PowerTabTextW

macro NumberToText(value)
    !value #= <value>

    ; Sign
    if <value> < 0
        db $EB
        !value #= -!value
    else
        db $EC
    endif
    !db_count #= !db_count+1

    ; Digits
    %_NumberToText(!value)
endmacro

!n = 0
!db_count = 0
macro _NumberToText(value)
    !n #= !n+1
    !{value!{n}} #= <value>
    if !{value!{n}} >= 10
       !{n!{n}} = !n
       %_NumberToText(safediv(!{value!{n!{n}}}, 10, 0))
       !{value!{n}} #= !{value!{n}}%10
    endif
    db $D4+!{value!{n}}
    !db_count #= !db_count+1
    !n #= !n-1
endmacro

macro WriteText(start_point)
    !memory_location := <start_point>
    !byte #= read1(!memory_location)
    while !byte != 0
        db !byte
        !memory_location #= !memory_location+1
        !byte #= read1(!memory_location)
    endif
    db 0
endmacro

; Tab Text

org !PowerTabTextPointer
ItemDescriptionPointers:
    dw PowerTabText
    dw MagicTabText
    dw SpeedTabText

org !PowerTabText
PowerTabText:
    db $AF, $62, $26 ; Power
    %NumberToText(!PowerIncrease)
    db $E0, $B2, $CD, $BA, $C6, $25, $BA ; /Stamina
    %NumberToText(!StaminaIncrease)
if !PowerTabIncreasesHit != 0
    db $E0, $A7, $2E ; /Hit
    %NumberToText(!HitIncrease)
    !db_count #= !db_count+4
endif
    db $00 ; Null
    !db_count #= !db_count+13

MagicTabText:
    db $AC, $BA, $C0, $C2, $BC ; Magic
    %NumberToText(!MagicIncrease)
    db $E0, $AC, $E8, $A3, $BE, $BF, $33, $5A ; /M.Defense
    %NumberToText(!MagicDefenseIncrease)
    db $00 ; Null
    !db_count #= !db_count+16

SpeedTabText:
    db $B2, $C9, $6D, $BD ; Speed
    %NumberToText(!SpeedIncrease)
if !PowerTabIncreasesHit == 0
    db $E0, $A7, $2E ; /Hit
    %NumberToText(!HitIncrease)
    !db_count #= !db_count+4
endif
    db $E0, $A4, $CF, $BA, $BD, $BE ; /Evade
    %NumberToText(!EvadeIncrease)
    db $00 ; Null
    !db_count #= !db_count+13

; Move other text

!OriginalTabDbCount = 30
!BK = bank(!PowerTabText)<<16
!db_diff #= !db_count-!OriginalTabDbCount
function text_pointer(offset) = !BK+read2(!PowerTabTextPointer+6+(offset*2))+!db_diff
function original_text_pointer(offset) = !BK+read2(!PowerTabTextPointer+6+(offset*2))

org !PowerTabTextPointer+6
    !i #= 0
    while !i <= 31
        dw text_pointer(!i)
        !i #= !i+1
    endif

!i #= 0
while !i <= 31
    org text_pointer(!i)
        %WriteText(original_text_pointer(!i))
    !i #= !i+1
endif

endif

; Free spaces / New routines

org $C37A30
warnpc $C38000

org $CDF9C0
if !BetterTabs != 0
macro StatCondition(value, statOffset, max, allow)
     if <value> > 0
         LDA $9A9B+<statOffset> : CMP #<max> : BCC <allow>
     elseif <value> < 0
         LDA $9A9B+<statOffset> : CMP #$01 : BCS <allow>
     endif
endmacro

TabCondition:
    CPY #$00 : BEQ .powerTab
    CPY #$02 : BEQ .speedTab
    CPY #$03 : BEQ .magicTab
    JML TabCondition.Disallow

    .powerTab
    %StatCondition(!PowerIncrease,   00, $63, .allow)
    %StatCondition(!StaminaIncrease, 01, $63, .allow)
    if !PowerTabIncreasesHit != 0
        %StatCondition(!HitIncrease, 04, $63, .allow)
    endif
    JML TabCondition.Disallow

    .speedTab
    %StatCondition(!SpeedIncrease, 02, $10, .allow)
    %StatCondition(!EvadeIncrease, 05, $63, .allow)
    if !PowerTabIncreasesHit == 0
        %StatCondition(!HitIncrease, 04, $63, .allow)
    endif
    JML TabCondition.Disallow

    .magicTab
    %StatCondition(!MagicIncrease,        03, $63, .allow)
    %StatCondition(!MagicDefenseIncrease, 06, $63, .allow)
    JML TabCondition.Disallow

    .allow
JML TabCondition.Allow

macro _IncreaseStat(statOffset, max, by)
    if <by> != 0
        if <by> < 0
            !by = -<by>
            LDA <statOffset>, X : SEC : SBC.b #!by
                BEQ ?loadMin
                BCC ?loadMin
                BRA ?setStat
            ?loadMin:
                LDA #$01
        else
            LDA <statOffset>, X : CLC : ADC.b #<by> : CMP #<max> : BCC ?setStat
                LDA #<max>
        endif
        ?setStat:
            STA <statOffset>, X
    endif
endmacro

macro IncreaseStat(statOffset, statOffset2, max, by)
    %_IncreaseStat(<statOffset>, <max>, <by>)
    %_IncreaseStat(<statOffset2>, <max>, <by>)
endmacro

TabIncrease:
    SEP #$20
    LDX $6F
    CMP #$00 : BEQ .powerTab
    CMP #$02 : BEQ .speedTabShort
    CMP #$03 : BEQ .magicTabShort
    JML TabIncrease.Return

    .speedTabShort
    BRL .speedTab

    .magicTabShort
    BRL .magicTab

    .powerTab
    %IncreaseStat($000B, $002F, $63, !PowerIncrease)
    %IncreaseStat($000C, $0030, $63, !StaminaIncrease)
    if !PowerTabIncreasesHit != 0
        %IncreaseStat($000F, $0032, $63, !HitIncrease)
    endif
    JML TabIncrease.Return

    .speedTab
    %IncreaseStat($000D, $0031, $10, !SpeedIncrease)
    %IncreaseStat($0010, $0033, $63, !EvadeIncrease)
    if !PowerTabIncreasesHit == 0
        %IncreaseStat($000F, $0032, $63, !HitIncrease)
    endif
    JML TabIncrease.Return

    .magicTab
    %IncreaseStat($000E, $0034, $63, !MagicIncrease)
    %IncreaseStat($0011, $0035, $63, !MagicDefenseIncrease)
JML TabIncrease.Return
endif

if !IncreaseExpGoldTech != 0
function is_power_of_two(x) = equal(1<<log2(x),x)

macro EachBit(prefix, value)
  !EachBit_value #= <value>
  !EachBit_i #= 0
  while !EachBit_value > 0
    !{<prefix>!{EachBit_i}} #= !EachBit_value%2
    !EachBit_value #= !EachBit_value>>1
    !EachBit_i #= !EachBit_i+1
  endif
  !<prefix>_length #= !EachBit_i
endmacro


macro MultiplyPoints(value, by, overLimit, eight_bits)
    if is_power_of_two(<by>)
        %ShiftPointsLeft(<value>, log2(<by>), <overLimit>, <eight_bits>)
    else
        if <eight_bits> != 0
            SEP #$20
        endif
        LDA <value>, X : STA $00
        if <eight_bits> != 0
            REP #$20
        endif
        ASL : BCS <overLimit>
        %EachBit(bit, <by>)
        !i #= !bit_length-2
        while !i >= 0
            if !{bit!{i}} == 1
                ADC $00 : BCS <overLimit>
            endif
            if !i > 0
                ASL : BCS <overLimit>
            endif
            !i #= !i-1
        endif
    endif
endmacro

macro ShiftPointsLeft(value, by, overLimit, eight_bits)
    if <eight_bits> != 0
        SEP #$20
    endif
    LDA <value>, X
    if <eight_bits> != 0
        REP #$20
    endif
    !by #= <by>
    while !by > 0
        ASL : BCS <overLimit>
        !by #= !by-1
    endif
endmacro

AddPoints:
    ; Experience
    if !GradualExpIncrease != 0
        PHY
        SEP #$20
        LDA $5E3F
        if !GradualExpMin <= 0
            CMP #$14 : BCS + ; if pc1 level is less than 20
                LDY #$0001
                BRA .startMultiplication
            +
        endif
        if !GradualExpMin <= 1
            CMP #$28 : BCS + ; if pc1 level is less than 40
                LDY #$0002
                BRA .startMultiplication
            +
        endif
        if !GradualExpMin <= 2
            CMP #$3C : BCS + ; if pc1 level is less than 60
                LDY #$0003
                BRA .startMultiplication
            +
        endif
        if !GradualExpMin <= 3
            CMP #$50 : BCS + ; if pc1 level is less than 80
                LDY #$0004
                BRA .startMultiplication
            +
        endif
        LDY #$0005
        .startMultiplication
            REP #$20
            LDA $CC5E00, X
        .multiplicationLoop
            DEY : BEQ .endMultiplication
            ASL : BCS .expOverLimit
        .endMultiplication
        PLY
    else
        %MultiplyPoints($CC5E00, !ExpIncrease, .expOverLimit, 0) ; multiply experience
    endif

    CLC : ADC $B28C
    BCC +
    .expOverLimit
        LDA #$FFFF
    +
    STA $B28C

    ; Money
    %MultiplyPoints($CC5E02, !GoldIncrease, .moneyOverLimit, 0)
    CLC : ADC $B2A5
    BCC +
    .moneyOverLimit
        LDA #$FFFF
    +
    STA $B2A5

    ; Tech Points
    TDC
    %MultiplyPoints($CC5E06, !TechIncrease, .techOverLimit, 1)
    CLC : ADC $B2DB
    BCC +
    .techOverLimit
        SEP #$20
        INC $B2DD
        REP #$20
    +
    STA $B2DB
JML AddPoints.ReturnPoint

endif

warnpc $CE0000

